/****************************************************************************
*
*                            Open Watcom Project
*
*    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  Fnsplit almost _splitpath workalike for Borland compatibility.
*
****************************************************************************/

#include <dos.h>
#include <string.h>

#ifndef WILDCARDS
 #define WILDCARDS		0x01
 #define EXTENSION		0x02
 #define FILENAME		0x04
 #define DIRECTORY		0x08
 #define DRIVE			0x10
#endif

_WCRTLINK int fnsplit( const char *path, char *drv, char *dir, char *name, char *ext ) {
    const char * end;
    const char * p;
    const char * s;
    int          retval = 0;

    if ( path[0] && path[1]==':' ) {
        if ( drv ) {
            *drv++ = *path++;
    	    *drv++ = *path++;
            *drv = '\0';
            retval += DRIVE;
        }
    } else if ( drv ) *drv = '\0';

    for( end = path; *end && *end != ':'; ) end++;

    for( p = end; p > path && *--p != '\\' && *p != '/'; ) {
        if ( *p == '.' ) {
                end = p;
                break;
        }
    }

    if ( ext ) for( s = end; ( *ext = *s++ ); ) ext++;
    if ( ext ) retval += EXTENSION;

    for( p = end; p > path; ) {
        if ( *--p == '\\' || *p == '/' ) {
            p++;
            break;
    	}
    }

    if ( name ) {
        for( s = p; s < end; ) *name++ = *s++;
        *name = '\0';
        retval += FILENAME;
    }

    if ( dir ) {
        for( s = path; s < p; ) *dir++ = *s++;
        *dir = '\0';
        retval += DIRECTORY;
    }

    if ( strchr( path, '*' ) != NULL || strchr( path, '?' ) != NULL ) {
        retval += WILDCARDS;
    }
    return( retval );
}

