/****************************************************************************
*
*                            Open Watcom Project
*
*    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  Searches the PATH environment variable for the file in
*               "name" and returns the full path.
*
****************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#ifdef __UNIX__
 #define SEP ':'
 #define PATHSEP "/"
#else
 #define SEP ';'
 #define PATHSEP "\\"
#endif

_WCRTLINK char *searchpath( const char *name )
{
    char *envptr = getenv( "PATH" );
    static char file[ _MAX_PATH ];
    file[ 0 ] = '\0';
    if( access( name, F_OK ) == 0 ) {
        strcpy( file, name );
        return( file );
    }
    if( envptr == NULL ) return( NULL );
    while( envptr && envptr[ 0 ] ) {/* While there are paths left to parse */
        char *tok = strchr( envptr, SEP );
        int  toklen;
        if( tok == NULL ) toklen = strlen( envptr );
        else toklen = tok - envptr;
    /*
     * The next code copies the name to the path directory and checks for
     * existance
     */
        memcpy( file, envptr, toklen );
        strcpy( file + toklen, PATHSEP );
        sprintf( file, "%s%s", file, name );
        if( access( file, F_OK ) == 0 ) return( file );
        envptr = tok;
        if( envptr ) envptr++;    /* Move on to the next one */
    }
    return( NULL );
}

